<template>
  <div class="airportInfo scroll-y">
    <div class="wrap">
      <Minheader
        :is-auth="true"
        :is-statuser="true"
        powerData="new_freight_forwarder_button"
        @addForm="addForm"
      >
        <template #header>
          <div class="status flex-wrap">
            <div class="manageTitle">货代管理</div>
          </div>
        </template></Minheader
      >
      <div class="app-containers">
        <DataTable
          :tableHeader="tableCols"
          :tableData="tableData"
          :tableBtnGroup="tableBtnGroup"
          :tableProperty="{ rowKey: 'ID' }"
          @btnClick="btnClick"
        />
      </div>
      <Dialog
        :flag="flag"
        :type="type"
        :msgTitle="msgTitle"
        :delName="tableForm.agentName"
        @resetForm="resetForm"
        @delRest="delRest"
        @submitForm="submitForm"
        @delRemove="delRemove"
      >
        <div class="diacont">
          <el-form
            :model="tableForm"
            :rules="formRules"
            ref="cargoInformationForm"
          >
            <el-row :gutter="24">
              <el-col>
                <el-form-item
                  label="货代名称"
                  size="default"
                  prop="agentName"
                  :rules="formRules.isNotNull"
                >
                  <el-input
                    v-model="tableForm.agentName"
                    placeholder="请输入货代名称"
                  />
                </el-form-item>
              </el-col>
              <el-col>
                <el-form-item
                  label="货代编码"
                  size="default"
                  prop="agentCode"
                  :rules="formRules.isNotNull"
                >
                  <el-input
                    v-model="tableForm.agentCode"
                    placeholder="请输入货代编码"
                  />
                </el-form-item>
              </el-col>
              <el-col>
                <el-form-item label="备注" size="default">
                  <el-input
                    type="textarea"
                    v-model="tableForm.agentDesc"
                    placeholder="请输入备注"
                  />
                </el-form-item>
              </el-col>
            </el-row>
          </el-form>
        </div>
      </Dialog>
    </div>
  </div>
</template>
<script setup lang="ts">
import DataTable from "@/components/tableTemp/index.vue";
import Minheader from "@/components/minheader/index.vue";
import Dialog from "@/components/dialog/index.vue";
import { Query, GeneralDataReception } from "@/api/webApi";
import { ElMessage } from "element-plus";
const formRules = useElement().formRules;
const page = ref<number>(0); //分页参数
const dataContent = ref<object>({});
const noMore = ref<Boolean>(false);
const rowTitle = ref<String>("");
const tableCols = ref([]); //表头数据
const serviceId = ref<String>("");
const tableObj = ref({}); //增删改数据缓存
const flag = ref<Boolean>(false); //弹窗开关
const type = ref<String>(""); //判断是否删除
const msgTitle = ref<String>("新增货代管理"); //弹窗标题
const tableColsCopys = reactive<Object>({}); //弹窗
const tableForm = reactive({
  agentID: "",
  agentName: "",
  agentCode: "",
  agentDesc: "",
  event: "",
}); //弹窗内容
//列表
const tableData = ref([]);
//表头
const state = reactive({
  list: [
    { label: "货代名称", key: "name" },
    { label: "货代编码", key: "china" },
    { label: "货代等级", key: "englin" },
    { label: "货代描述", key: "two" },
  ],
  listLoading: true,
});
const tableBtnGroup = ref([
  {
    name: "编辑",
    className: "editBtn",
    param: 2,
    is: "freight_forwarder_editor_button",
  },
  {
    name: "删除",
    className: "delBtn",
    param: 3,
    is: "freight_forwarder_deletion_button",
  },
]);
//新增
const addForm = () => {
  msgTitle.value = "新增货代管理";
  flag.value = true;
  type.value = "";
  tableForm.event = 1;
};
//取消
const resetForm = () => {
  flag.value = false;
  tableForm.agentID = "";
  tableForm.agentName = "";
  tableForm.agentCode = "";
  tableForm.agentDesc = "";
};
//编辑
const editDialog = (data) => {
  msgTitle.value = "编辑货代管理";
  flag.value = true;
  type.value = "";
  tableForm.name = data.name;
  tableForm.china = data.china;
  tableForm.two = data.two;
};
//删除
const eleDialog = () => {
  msgTitle.value = "删除货代管理";
  flag.value = true;
  type.value = "del";
};
const delRemove = () => {
  tableForm.event = 3;
  generalDataReception(tableForm);
};
//删除
const delRest = () => {
  flag.value = false;
};
//编辑-删除
const btnClick = (row, index, param) => {
  if (param === 2) {
    msgTitle.value = "编辑货代管理";
    flag.value = true;
    type.value = "";
    tableForm.event = 2;
    tableForm.agentID = index.agentID;
    tableForm.agentName = index.agentName;
    tableForm.agentCode = index.agentCode;
    tableForm.agentDesc = index.agentDesc;
  } else if (param === 3) {
    msgTitle.value = "删除货代管理";
    flag.value = true;
    type.value = "del";
    tableForm.event = 3;
    tableForm.agentID = index.agentID;
    tableForm.agentName = index.agentName;
    tableForm.agentCode = index.agentCode;
    tableForm.agentDesc = index.agentDesc;
  } else if (param === 4) {
  }
};
//获取表格数据
const getQuery = async () => {
  try {
    const { code, returnData } = await Query({
      id: DATACONTENT_ID.forwarderNodeId,
      needPage: ++page.value,
      dataContent: Object.values(dataContent.value),
    });
    if (code === "0") {
      if (returnData.listValues.length === 0) {
        page.value--;
        noMore.value = true;
      }
      const titleColumn = returnData.columnSet.find(
        (item) => item.needShow === 1
      );
      if (titleColumn) {
        rowTitle.value = titleColumn.columnName;
      }
      tableData.value.push(...returnData.listValues);
      tableCols.value = returnData.columnSet;
      tableCols.value.forEach((element) => {
        element.label = element.columnLabel;
        element.key = element.columnName;
        // if (element.columnName === "queryTemplate") {
        //   element.width = "300px";
        // }
      });
      serviceId.value = returnData.submitID;
    } else {
      page.value--;
    }
  } catch (error) {
    page.value--;
  }
};
//确认提交
const cargoInformationForm: any = ref(null);
const submitForm = () => {
  cargoInformationForm.value.validate((valid: any) => {
    if (valid) {
      generalDataReception(tableForm);
    } else {
      return false;
    }
  });
};
const resetTable = () => {
  page.value = 0;
  noMore.value = false;
  tableData.value = [];
};
//新增-编辑-删除
const generalDataReception = async (data) => {
  try {
    data = {
      ...data,
    };
    const { code } = await GeneralDataReception({
      serviceId: serviceId.value,
      dataContent: JSON.stringify(data),
    });
    if (code == 0) {
      ElMessage.success(`操作成功`);
      // this.$message.success("操作成功");
      resetTable();
      getQuery();
      resetForm();
      flag.value = false;
      // rmFlag.value = false;
      tableObj.value = {};
      // this.$router.go(0);
    } else {
      ElMessage.error(`操作失败`);
      // this.$message.error("操作失败");
      // this.flag = false;
      // this.rmFlag = false;
      tableObj.value = {};
      resetForm();
    }
  } catch (error) {
    flag.value = false;
    //  rmFlag.value = false;
    tableObj.value = {};
    resetForm();
  }
};
getQuery();
</script>
<style lang="scss" scoped>
::v-deep .el-form-item__label {
  width: 80px;
}
</style>
